
Ruby - Bug #623

optparseでオプションが重複していると--helpと挙動が違う

10/09/2008 04:12 PM - znz (Kazuhiro NISHIYAMA)

Status: Closed   

Priority: Normal   

Assignee: nobu (Nobuyoshi Nakada)   

Target version: 1.9.1 Release Candidate   

ruby -v:  Backport:  

Description

=begin

バージョンに迷ってredmineに登録していなかった[ruby-dev:35801]の件を

redmineの方に入れておきます。

opts.onでオプションが重複していると--helpでは

先に出てきた方に対応するように表示されるのに

実際には後に出てきたの方の意味になります。

% cat o.rb

#!/usr/bin/ruby

require 'optparse'

ARGV.options do |opts|

opts.on("-t", "--test-option"){p "test-option"}

opts.on("-t", "--another-test-option"){p "another-test-option"}

opts.parse!

end

% ruby18 -v o.rb -h

ruby 1.8.7 (2008-08-08 revision 0) [i686-linux]

Usage: o [options]

-t, --test-option

--another-test-option

% ruby18 -v o.rb -t

ruby 1.8.7 (2008-08-08 revision 0) [i686-linux]

"another-test-option"

% ruby-1.8.6 -v o.rb -t

ruby 1.8.6 (2008-08-08 patchlevel 286) [i686-linux]

"another-test-option"

% ruby-1.8.7 -v o.rb -t

ruby 1.8.7 (2008-08-08 patchlevel 71) [i686-linux]

"another-test-option"

% ruby-trunk -v o.rb -t

ruby 1.9.0 (2008-08-07 revision 18407) [i686-linux]

"another-test-option"

%

=end

History

#1 - 12/11/2008 12:35 PM - yugui (Yuki Sonoda)

- Target version set to 1.9.1 Release Candidate

=begin

=end

#2 - 12/21/2008 12:10 AM - yugui (Yuki Sonoda)

- Due date set to 12/24/2008
=begin

=end

#3 - 12/26/2008 03:57 PM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

- % Done changed from 0 to 100

=begin

Applied in changeset r21066.

=end
